blob: 62bd22578b2707288648a937af31be011976e569 [file] [log] [blame]
Fam Zheng6b560c72017-09-05 10:11:52 +08001#!/bin/bash
2#
3# Author: Fam Zheng <famz@redhat.com>
4#
5# Archive source tree, including submodules. This is created for test code to
6# export the source files, in order to be built in a different environment,
7# such as in a docker instance or VM.
8#
9# This code is licensed under the GPL version 2 or later. See
10# the COPYING file in the top-level directory.
11
12error() {
13 printf %s\\n "$*" >&2
14 exit 1
15}
16
17if test $# -lt 1; then
18 error "Usage: $0 <output tarball>"
19fi
20
Mao Zhongyi934821e2018-10-15 17:17:34 +080021tar_file=$(realpath "$1")
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010022list_file="${tar_file}.list"
23vroot_dir="${tar_file}.vroot"
Fam Zheng6b560c72017-09-05 10:11:52 +080024
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010025# We want a predictable list of submodules for builds, that is
26# independent of what the developer currently has initialized
27# in their checkout, because the build environment is completely
28# different to the host OS.
Daniel P. Berrange92712822017-09-29 11:11:58 +010029submodules="dtc ui/keycodemapdb"
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010030
31trap "status=$?; rm -rf \"$list_file\" \"$vroot_dir\"; exit \$status" 0 1 2 3 15
32
33if git diff-index --quiet HEAD -- &>/dev/null
34then
35 HEAD=HEAD
36else
Mao Zhongyi934821e2018-10-15 17:17:34 +080037 HEAD=$(git stash create)
Fam Zheng6b560c72017-09-05 10:11:52 +080038fi
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010039git clone --shared . "$vroot_dir"
40test $? -ne 0 && error "failed to clone into '$vroot_dir'"
Fam Zheng6b560c72017-09-05 10:11:52 +080041
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010042cd "$vroot_dir"
43test $? -ne 0 && error "failed to change into '$vroot_dir'"
44
45git checkout $HEAD
46test $? -ne 0 && error "failed to checkout $HEAD revision"
47
48for sm in $submodules; do
49 git submodule update --init $sm
50 test $? -ne 0 && error "failed to init submodule $sm"
51done
Fam Zheng6b560c72017-09-05 10:11:52 +080052
53if test -n "$submodules"; then
54 {
55 git ls-files || error "git ls-files failed"
56 for sm in $submodules; do
57 (cd $sm; git ls-files) | sed "s:^:$sm/:"
58 if test "${PIPESTATUS[*]}" != "0 0"; then
59 error "git ls-files in submodule $sm failed"
60 fi
61 done
62 } | grep -x -v $(for sm in $submodules; do echo "-e $sm"; done) > "$list_file"
63else
64 git ls-files > "$list_file"
65fi
66
67if test $? -ne 0; then
68 error "failed to generate list file"
69fi
70
71tar -cf "$tar_file" -T "$list_file" || error "failed to create tar file"
72
73exit 0